; 
    include \masm32\include\masm32rt.inc
; 

comment * -----------------------------------------------------
                        Build this  template with
                       "CONSOLE ASSEMBLE AND LINK"
        ----------------------------------------------------- *

        EXTERNDEF d_e_f_a_u_l_t__n_u_l_l_$:DWORD

get_line_count PROTO :DWORD,:DWORD
mrrfile        PROTO :DWORD
mrralloc       PROTO :DWORD

    .code

start:
   
; 

    call main
    inkey
    exit

; 

main proc

    LOCAL hArr  :DWORD
    LOCAL void  :DWORD
    LOCAL acnt  :DWORD

    push ebx
    push esi
    push edi

    invoke GetTickCount
    push eax

  ; --------------------
  ; load file into array
  ; --------------------

;##########################################################################
;mov hArr, arrfile$("\masm32\include\windows.inc")

        INVOKE  mrrfile,chr$("\masm32\include\windows.inc")
        mov     hArr,eax
;##########################################################################

    mov acnt, arrcnt$(hArr)             ; get the array member count
    invoke GetTickCount
    pop ecx
    sub eax, ecx
    print str$(eax)," ms disk read and array load",13,10,13,10
    print "File is now loaded, do you want to display it ? 'y' for yes",13,10
    getkey                              ; wait for a key stroke

    switch eax
      case "y"                          ; if it is "y" display the file
        mov ebx, 1                      ; set index to 1 for 1 based array
      @@:
        print arrget$(hArr,ebx),13,10   ; display each line in the array
        add ebx, 1
        cmp ebx, acnt
        jle @B
    endsw

    mov void, arrfree$(hArr)            ; deallocate the entire array

exit_main:
    pop edi
    pop esi
    pop ebx

    ret

main endp

; 
; 

mrrfile proc file_name:DWORD

    LOCAL arr   :DWORD
    LOCAL hMem  :DWORD
    LOCAL flen  :DWORD
    LOCAL lcnt  :DWORD
    LOCAL pbuf  :DWORD
    LOCAL spos  :DWORD
    LOCAL void  :DWORD

    push ebx

   mov hMem, InputFile(file_name)
   mov lcnt, rv(get_line_count,eax,ecx)
   mov flen, ecx
   mov pbuf, alloc(ecx)

;##########################################################################
;mov arr, arralloc$(lcnt)

        INVOKE  mrralloc,lcnt
        mov     arr,eax
;##########################################################################

    mov spos, 0
    mov ebx, 1

@@:
    mov spos, rv(readline,hMem,pbuf,spos)
    mov void, arrset$(arr,ebx,pbuf)
    add ebx, 1
    cmp ebx, lcnt
    jbe @B

    free pbuf
    free hMem
    mov eax, arr
    pop ebx
    ret

mrrfile endp

; 
; 

    align 16

mrralloc proc mcnt:DWORD

  ; ----------------------------------------------------------------
  ; return values = handle of pointer array or 0 on allocation error
  ; ----------------------------------------------------------------
    push esi

    mov eax, mcnt                               ; load the member count into EAX
    add eax, 1                                  ; correct for 1 based array

;##########################################################################
    or  eax,1                                   ; make usable element count even
;##########################################################################

    lea eax, [eax*4]                            ; multiply it by 4 for memory size

    invoke GlobalAlloc,GMEM_FIXED,eax
    mov esi, eax

    test eax, eax                               ; if allocation failure return zero
    jz quit

    mov eax, esi
    mov ecx, mcnt
    mov DWORD PTR [eax], ecx                    ; write count to 1st member

    xor edx, edx
  @@:
    add edx, 1                                  ; write adress of null string to all members
    mov [eax+edx*4],OFFSET d_e_f_a_u_l_t__n_u_l_l_$
    cmp edx, ecx
    jle @B

    mov eax, esi                                ; return pointer array handle

  quit:
    pop esi

    ret

mrralloc endp

; 

end start

